/* USER CODE BEGIN Header */
/**
  ******************************************************************************
  * @file           : main.c
  * @brief          : Main program body
  ******************************************************************************
  * @attention
  *
  * Copyright (c) 2023 STMicroelectronics.
  * All rights reserved.
  *
  * This software is licensed under terms that can be found in the LICENSE file
  * in the root directory of this software component.
  * If no LICENSE file comes with this software, it is provided AS-IS.
  *
  ******************************************************************************
  */
/* USER CODE END Header */
/* Includes ------------------------------------------------------------------*/
#include "main.h"

/* Private includes ----------------------------------------------------------*/
/* USER CODE BEGIN Includes */
#include <string.h>

#include "LCD1602.h"
#include <stdlib.h>
#include <stdio.h>


/* USER CODE END Includes */

/* Private typedef -----------------------------------------------------------*/
/* USER CODE BEGIN PTD */

/* USER CODE END PTD */

/* Private define ------------------------------------------------------------*/
/* USER CODE BEGIN PD */

/* USER CODE END PD */

/* Private macro -------------------------------------------------------------*/
/* USER CODE BEGIN PM */
#define FRAM_ADDRESS         0xA0 //0b10100000
#define FRAM_ADDRESS1 		0xA0
#define RFID_ADDRESS     		 0x00
#define RFID_ADDRESS1           0x3C
#define RFID_MEM_SIZE           12
/* USER CODE END PM */

/* Private variables ---------------------------------------------------------*/
I2C_HandleTypeDef hi2c1;

TIM_HandleTypeDef htim1;
TIM_HandleTypeDef htim3;

UART_HandleTypeDef huart2;
UART_HandleTypeDef huart3;

/* USER CODE BEGIN PV */
uint8_t card_buffer[12]={0,0,0,0,0,0,0,0,0,0,0,0};
uint8_t Rx_data[12]={0};
uint8_t Rx_data1[12]={0,0,0,0,0,0,0,0,0,0,0,0};
uint8_t Rx_data2[12]={0,0,0,0,0,0,0,0,0,0,0,0};
uint8_t Rx_data3[12]={0,0,0,0,0,0,0,0,0,0,0,0};
uint8_t Checwritekdata1[12]={1,2,3,4,5,6,7,8,9,0,11,12};
uint8_t CheckReaddata[12]={0};
uint8_t erase_data[12]={0xFF};
uint8_t Checwritekdata2[12]={13,14,15,16,17,18,19,20,21,22,23,24};
uint8_t CheckReaddata2[12]={0};


int rxflag1=0;
int regis_flag=0;
int count=0;
int count1=0;
int granted_count=0;
int denied_count=0;
int erase_flag=0;
uint8_t card_number=0;
uint8_t MAX_VALUE=5;
int loop_count=0;
int loop_count2=0;
int read_id=0;
int granted =0;
char stri[] =
		" GET https://api.thingspeak.com/update?api_key=K6X7NTKF14N6PCO2&field1=";

/* USER CODE END PV */

/* Private function prototypes -----------------------------------------------*/
void SystemClock_Config(void);
static void MX_GPIO_Init(void);
static void MX_USART3_UART_Init(void);
static void MX_I2C1_Init(void);
static void MX_TIM3_Init(void);
static void MX_TIM1_Init(void);
static void MX_USART2_UART_Init(void);
/* USER CODE BEGIN PFP */
#ifdef __GNUC__
  /* With GCC/RAISONANCE, small printf (option LD Linker->Libraries->Small printf
     set to 'Yes') calls __io_putchar() */
  #define PUTCHAR_PROTOTYPE int __io_putchar(int ch)
#else
  #define PUTCHAR_PROTOTYPE int fputc(int ch, FILE *f)
#endif /* __GNUC__ */
/* USER CODE END PFP */

/* Private user code ---------------------------------------------------------*/
/* USER CODE BEGIN 0 */
int row=0;
int col=0;
PUTCHAR_PROTOTYPE
{
  /* Place your implementation of fputc here */
  /* e.g. write a character to the EVAL_COM1 and Loop until the end of transmission */

  HAL_UART_Transmit(&huart2, (uint8_t *)&ch, 1, 0xFFFF);

  return ch;
}
/* USER CODE END 0 */

/**
  * @brief  The application entry point.
  * @retval int
  */
int main(void)
{
  /* USER CODE BEGIN 1 */

  /* USER CODE END 1 */

  /* MCU Configuration--------------------------------------------------------*/

  /* Reset of all peripherals, Initializes the Flash interface and the Systick. */
  HAL_Init();

  /* USER CODE BEGIN Init */

  /* USER CODE END Init */

  /* Configure the system clock */
  SystemClock_Config();

  /* USER CODE BEGIN SysInit */

  /* USER CODE END SysInit */

  /* Initialize all configured peripherals */
  MX_GPIO_Init();
  MX_USART3_UART_Init();
  MX_I2C1_Init();
  MX_TIM3_Init();
  MX_TIM1_Init();
  MX_USART2_UART_Init();

  /* USER CODE BEGIN 2 */
  HAL_UART_Init(&huart2);
  HAL_Delay(10);
  HAL_TIM_Base_Start(&htim1);
  HAL_TIM_PWM_Init(&htim3);
  HAL_TIM_PWM_Start(&htim3,TIM_CHANNEL_1);
  /* USER CODE END 2 */

  /* Infinite loop */
  /* USER CODE BEGIN WHILE */

  /****************************************************************************************************************************************************************/

                                // Write your code here//


















  /****************************************************************************************************************************************************************/


    /* USER CODE END WHILE */

    /* USER CODE BEGIN 3 */

  /* USER CODE END 3 */
}

/**
  * @brief System Clock Configuration
  * @retval None
  */
void SystemClock_Config(void)
{
  RCC_OscInitTypeDef RCC_OscInitStruct = {0};
  RCC_ClkInitTypeDef RCC_ClkInitStruct = {0};

  /** Configure the main internal regulator output voltage
  */
  if (HAL_PWREx_ControlVoltageScaling(PWR_REGULATOR_VOLTAGE_SCALE1) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the RCC Oscillators according to the specified parameters
  * in the RCC_OscInitTypeDef structure.
  */
  RCC_OscInitStruct.OscillatorType = RCC_OSCILLATORTYPE_MSI;
  RCC_OscInitStruct.MSIState = RCC_MSI_ON;
  RCC_OscInitStruct.MSICalibrationValue = 0;
  RCC_OscInitStruct.MSIClockRange = RCC_MSIRANGE_6;
  RCC_OscInitStruct.PLL.PLLState = RCC_PLL_ON;
  RCC_OscInitStruct.PLL.PLLSource = RCC_PLLSOURCE_MSI;
  RCC_OscInitStruct.PLL.PLLM = 1;
  RCC_OscInitStruct.PLL.PLLN = 36;
  RCC_OscInitStruct.PLL.PLLP = RCC_PLLP_DIV7;
  RCC_OscInitStruct.PLL.PLLQ = RCC_PLLQ_DIV2;
  RCC_OscInitStruct.PLL.PLLR = RCC_PLLR_DIV2;
  if (HAL_RCC_OscConfig(&RCC_OscInitStruct) != HAL_OK)
  {
    Error_Handler();
  }

  /** Initializes the CPU, AHB and APB buses clocks
  */
  RCC_ClkInitStruct.ClockType = RCC_CLOCKTYPE_HCLK|RCC_CLOCKTYPE_SYSCLK
                              |RCC_CLOCKTYPE_PCLK1|RCC_CLOCKTYPE_PCLK2;
  RCC_ClkInitStruct.SYSCLKSource = RCC_SYSCLKSOURCE_PLLCLK;
  RCC_ClkInitStruct.AHBCLKDivider = RCC_SYSCLK_DIV1;
  RCC_ClkInitStruct.APB1CLKDivider = RCC_HCLK_DIV1;
  RCC_ClkInitStruct.APB2CLKDivider = RCC_HCLK_DIV1;

  if (HAL_RCC_ClockConfig(&RCC_ClkInitStruct, FLASH_LATENCY_4) != HAL_OK)
  {
    Error_Handler();
  }
}

/**
  * @brief I2C1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_I2C1_Init(void)
{

  /* USER CODE BEGIN I2C1_Init 0 */

  /* USER CODE END I2C1_Init 0 */

  /* USER CODE BEGIN I2C1_Init 1 */

  /* USER CODE END I2C1_Init 1 */
  hi2c1.Instance = I2C1;
  hi2c1.Init.Timing = 0x10808DD3;
  hi2c1.Init.OwnAddress1 = 0;
  hi2c1.Init.AddressingMode = I2C_ADDRESSINGMODE_7BIT;
  hi2c1.Init.DualAddressMode = I2C_DUALADDRESS_DISABLE;
  hi2c1.Init.OwnAddress2 = 0;
  hi2c1.Init.OwnAddress2Masks = I2C_OA2_NOMASK;
  hi2c1.Init.GeneralCallMode = I2C_GENERALCALL_DISABLE;
  hi2c1.Init.NoStretchMode = I2C_NOSTRETCH_DISABLE;
  if (HAL_I2C_Init(&hi2c1) != HAL_OK)
  {
    Error_Handler();
  }

  /** Configure Analogue filter
  */
  if (HAL_I2CEx_ConfigAnalogFilter(&hi2c1, I2C_ANALOGFILTER_ENABLE) != HAL_OK)
  {
    Error_Handler();
  }

  /** Configure Digital filter
  */
  if (HAL_I2CEx_ConfigDigitalFilter(&hi2c1, 0) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN I2C1_Init 2 */

  /* USER CODE END I2C1_Init 2 */

}

/**
  * @brief TIM1 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM1_Init(void)
{

  /* USER CODE BEGIN TIM1_Init 0 */

  /* USER CODE END TIM1_Init 0 */

  TIM_ClockConfigTypeDef sClockSourceConfig = {0};
  TIM_MasterConfigTypeDef sMasterConfig = {0};

  /* USER CODE BEGIN TIM1_Init 1 */

  /* USER CODE END TIM1_Init 1 */
  htim1.Instance = TIM1;
  htim1.Init.Prescaler = 64-1;
  htim1.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim1.Init.Period = 65535;
  htim1.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim1.Init.RepetitionCounter = 0;
  htim1.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  if (HAL_TIM_Base_Init(&htim1) != HAL_OK)
  {
    Error_Handler();
  }
  sClockSourceConfig.ClockSource = TIM_CLOCKSOURCE_INTERNAL;
  if (HAL_TIM_ConfigClockSource(&htim1, &sClockSourceConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_OC4REF;
  sMasterConfig.MasterOutputTrigger2 = TIM_TRGO2_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim1, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM1_Init 2 */

  /* USER CODE END TIM1_Init 2 */

}

/**
  * @brief TIM3 Initialization Function
  * @param None
  * @retval None
  */
static void MX_TIM3_Init(void)
{

  /* USER CODE BEGIN TIM3_Init 0 */

  /* USER CODE END TIM3_Init 0 */

  TIM_MasterConfigTypeDef sMasterConfig = {0};
  TIM_OC_InitTypeDef sConfigOC = {0};

  /* USER CODE BEGIN TIM3_Init 1 */

  /* USER CODE END TIM3_Init 1 */
  htim3.Instance = TIM3;
  htim3.Init.Prescaler = 36;
  htim3.Init.CounterMode = TIM_COUNTERMODE_UP;
  htim3.Init.Period = 40000;
  htim3.Init.ClockDivision = TIM_CLOCKDIVISION_DIV1;
  htim3.Init.AutoReloadPreload = TIM_AUTORELOAD_PRELOAD_DISABLE;
  if (HAL_TIM_PWM_Init(&htim3) != HAL_OK)
  {
    Error_Handler();
  }
  sMasterConfig.MasterOutputTrigger = TIM_TRGO_RESET;
  sMasterConfig.MasterSlaveMode = TIM_MASTERSLAVEMODE_DISABLE;
  if (HAL_TIMEx_MasterConfigSynchronization(&htim3, &sMasterConfig) != HAL_OK)
  {
    Error_Handler();
  }
  sConfigOC.OCMode = TIM_OCMODE_PWM1;
  sConfigOC.Pulse = 0;
  sConfigOC.OCPolarity = TIM_OCPOLARITY_HIGH;
  sConfigOC.OCFastMode = TIM_OCFAST_DISABLE;
  if (HAL_TIM_PWM_ConfigChannel(&htim3, &sConfigOC, TIM_CHANNEL_1) != HAL_OK)
  {
    Error_Handler();
  }
  if (HAL_TIM_PWM_ConfigChannel(&htim3, &sConfigOC, TIM_CHANNEL_2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN TIM3_Init 2 */

  /* USER CODE END TIM3_Init 2 */
  HAL_TIM_MspPostInit(&htim3);

}

/**
  * @brief USART2 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART2_UART_Init(void)
{

  /* USER CODE BEGIN USART2_Init 0 */

  /* USER CODE END USART2_Init 0 */

  /* USER CODE BEGIN USART2_Init 1 */

  /* USER CODE END USART2_Init 1 */
  huart2.Instance = USART2;
  huart2.Init.BaudRate = 9600;
  huart2.Init.WordLength = UART_WORDLENGTH_8B;
  huart2.Init.StopBits = UART_STOPBITS_1;
  huart2.Init.Parity = UART_PARITY_NONE;
  huart2.Init.Mode = UART_MODE_TX_RX;
  huart2.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart2.Init.OverSampling = UART_OVERSAMPLING_16;
  huart2.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart2.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart2) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART2_Init 2 */

  /* USER CODE END USART2_Init 2 */

}

/**
  * @brief USART3 Initialization Function
  * @param None
  * @retval None
  */
static void MX_USART3_UART_Init(void)
{

  /* USER CODE BEGIN USART3_Init 0 */

  /* USER CODE END USART3_Init 0 */

  /* USER CODE BEGIN USART3_Init 1 */

  /* USER CODE END USART3_Init 1 */
  huart3.Instance = USART3;
  huart3.Init.BaudRate = 9600;
  huart3.Init.WordLength = UART_WORDLENGTH_8B;
  huart3.Init.StopBits = UART_STOPBITS_1;
  huart3.Init.Parity = UART_PARITY_NONE;
  huart3.Init.Mode = UART_MODE_TX_RX;
  huart3.Init.HwFlowCtl = UART_HWCONTROL_NONE;
  huart3.Init.OverSampling = UART_OVERSAMPLING_16;
  huart3.Init.OneBitSampling = UART_ONE_BIT_SAMPLE_DISABLE;
  huart3.AdvancedInit.AdvFeatureInit = UART_ADVFEATURE_NO_INIT;
  if (HAL_UART_Init(&huart3) != HAL_OK)
  {
    Error_Handler();
  }
  /* USER CODE BEGIN USART3_Init 2 */

  /* USER CODE END USART3_Init 2 */

}

/**
  * @brief GPIO Initialization Function
  * @param None
  * @retval None
  */
static void MX_GPIO_Init(void)
{
  GPIO_InitTypeDef GPIO_InitStruct = {0};
/* USER CODE BEGIN MX_GPIO_Init_1 */
/* USER CODE END MX_GPIO_Init_1 */

  /* GPIO Ports Clock Enable */
  __HAL_RCC_GPIOA_CLK_ENABLE();
  __HAL_RCC_GPIOC_CLK_ENABLE();
  __HAL_RCC_GPIOB_CLK_ENABLE();

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOB, GPIO_PIN_14|GPIO_PIN_15, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOC, GPIO_PIN_8, GPIO_PIN_RESET);

  /*Configure GPIO pin Output Level */
  HAL_GPIO_WritePin(GPIOA, GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_10, GPIO_PIN_RESET);

  /*Configure GPIO pins : PA0 PA1 PA4 */
  GPIO_InitStruct.Pin = GPIO_PIN_0|GPIO_PIN_1|GPIO_PIN_4;
  GPIO_InitStruct.Mode = GPIO_MODE_IT_RISING;
  GPIO_InitStruct.Pull = GPIO_PULLUP;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /*Configure GPIO pins : PB14 PB15 */
  GPIO_InitStruct.Pin = GPIO_PIN_14|GPIO_PIN_15;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOB, &GPIO_InitStruct);

  /*Configure GPIO pin : PC8 */
  GPIO_InitStruct.Pin = GPIO_PIN_8;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOC, &GPIO_InitStruct);

  /*Configure GPIO pins : PA8 PA9 PA10 */
  GPIO_InitStruct.Pin = GPIO_PIN_8|GPIO_PIN_9|GPIO_PIN_10;
  GPIO_InitStruct.Mode = GPIO_MODE_OUTPUT_PP;
  GPIO_InitStruct.Pull = GPIO_NOPULL;
  GPIO_InitStruct.Speed = GPIO_SPEED_FREQ_LOW;
  HAL_GPIO_Init(GPIOA, &GPIO_InitStruct);

  /* EXTI interrupt init*/
  HAL_NVIC_SetPriority(EXTI0_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(EXTI0_IRQn);

  HAL_NVIC_SetPriority(EXTI1_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(EXTI1_IRQn);

  HAL_NVIC_SetPriority(EXTI4_IRQn, 0, 0);
  HAL_NVIC_EnableIRQ(EXTI4_IRQn);

/* USER CODE BEGIN MX_GPIO_Init_2 */
/* USER CODE END MX_GPIO_Init_2 */
}

/* USER CODE BEGIN 4 */

void lcd_display_device_name()
{
	lcd_clear();
    HAL_Delay(100);
	lcd_put_cur(0, 0);
	lcd_send_string(" ");
	lcd_put_cur(1, 0);
	lcd_send_string("");
	lcd_clear();
	HAL_Delay(1000);
	lcd_put_cur(0, 0);
	lcd_send_string("FAST TAG ");
	lcd_put_cur(1, 0);
    lcd_send_string("  READER ");

	HAL_Delay(3000);

}
void register_newcard() {
	lcd_clear();
	lcd_put_cur(0, 0);
	lcd_send_string("Registering ID..  ");
	HAL_Delay(10);
	registration();
	regis_flag = 0;
}

void check_entry()
{

	HAL_Delay(10);
	check_local();

}

void erase_cardmem()
{
	lcd_clear();
	lcd_put_cur(0, 0);
	 lcd_send_string("Erasing..  ");
	 HAL_Delay(1000);
	for (int i = count; i >= 0; i--) {
		HAL_I2C_Mem_Write(&hi2c1, FRAM_ADDRESS, (RFID_ADDRESS + 12 * i),
				I2C_MEMADD_SIZE_8BIT, (uint8_t*) erase_data, sizeof(erase_data),
				100);
		HAL_Delay(100);

	}
	lcd_clear();
	lcd_put_cur(0, 0);
	lcd_send_string("Erased  ");
	HAL_Delay(100);
	lcd_put_cur(1, 0);
	lcd_send_string(" Memory");
	HAL_Delay(1000);
	count=0;
	erase_flag=0;
}
void registration()
{

	      UART_Start_Receive_IT(&huart3, (uint8_t*)Rx_data,12);
		  HAL_Delay(1000);
		  lcd_initialise();
		  lcd_clear();
		  HAL_Delay(100);
		  lcd_put_cur(0, 0);

		 lcd_send_string(" ");
		 lcd_put_cur(1, 0);

		  lcd_send_string("");
	      lcd_clear();
		  HAL_Delay(1000);

		  HAL_Delay(100);
		  lcd_put_cur(0, 0);
		  lcd_send_string("Show Card - Reg   ");
		  while(!rxflag1);
		 if(rxflag1)
		{

	    count++;

//				  for(int i=0;i<=11;i++)
//							  			   {
//							  			   Rx_data1[i]=Rx_data[i];
//							  			   HAL_Delay(10);
//							  			   }

	    HAL_Delay(30);
		HAL_I2C_Mem_Write(&hi2c1, FRAM_ADDRESS , (RFID_ADDRESS +12*count), I2C_MEMADD_SIZE_8BIT,(uint8_t *) Rx_data, sizeof(Rx_data), 100);
		HAL_Delay(100);

		card_number=count;
	    char snum[5];
	    itoa(card_number, snum, 10);
	    lcd_clear();
	    lcd_put_cur(0, 0);
	    lcd_send_string("Registration  ");
	    HAL_Delay(500);
	    lcd_put_cur(1, 0);
	    lcd_send_string(" Successful  ");
	    HAL_Delay(1000);

	    lcd_clear();
	    lcd_put_cur(0, 0);
	    lcd_send_string("Registration ID  ");
	    HAL_Delay(100);
	    lcd_put_cur(1, 0);
        lcd_send_string(snum);
        HAL_Delay(1000);
       	rxflag1=0;

}
}

void check_local()
{
	UART_Start_Receive_IT(&huart3, (uint8_t*)Rx_data,sizeof (Rx_data));  // rfid - > pc5
		  HAL_Delay(50);

		  lcd_clear();
		  lcd_put_cur(0, 0);
		  lcd_send_string("Show Card...  ");

		  HAL_Delay(10);

		  // while(!rxflag);


		  if(rxflag1)
		  {

			  rxflag1=0;

			  for(int i=0;i<=11;i++)
			     {
			  	    Rx_data1[i]=Rx_data[i];
			  		HAL_Delay(50);
			  	}
			  HAL_Delay(30);

			  lcd_clear();
			 		  lcd_put_cur(0, 0);
			 		  lcd_send_string("Verify Process...  ");
			 		 HAL_Delay(20);

//			 HAL_Delay(30);

			  for(int i =count;i>=0;i--)
			  {
				  HAL_I2C_Mem_Read(&hi2c1, FRAM_ADDRESS , RFID_ADDRESS +12*i, I2C_MEMADD_SIZE_8BIT,(uint8_t *) card_buffer, sizeof(card_buffer), 100);


				  for(int j=0;j<=11;j++)
				 	  {
				 		 if(Rx_data1[j]==card_buffer[j])
				 		 {
				 			 count1++;
				 			HAL_Delay(30);
				 		 }
				 		 HAL_Delay(10);

				 	  }

				  HAL_Delay(10);
				  if(count1 >=12)
				  {
					count1=0;
					lcd_clear();
								  		  lcd_put_cur(0, 0);
								  		  granted_count ++;
								  		  lcd_send_string("ACCESS   ");
								          HAL_Delay(100);
								          lcd_put_cur(1, 0);
								      	  lcd_send_string("GRANTED   ");
								          HAL_Delay(1000);
								          read_id=i;
								          granted=1;



 char tnum[5];
 itoa(read_id, tnum, 10);

 lcd_clear();
 lcd_put_cur(0, 0);
								          lcd_send_string("VERIFIED ID    ");
								          HAL_Delay(100);
								          lcd_put_cur(1, 0);
								          lcd_send_string(tnum);
								          HAL_Delay(1000);

								          for(int k=0;k<=90;k++)
								           {
								            set_servo_angle(k);
								          	HAL_Delay(10);
								            }
								           HAL_Delay(2000);

								         for(int k=89;k>=0;k--)
								           {
								          	set_servo_angle(k);
								          	HAL_Delay(10);
								          	 }



lcd_clear();
lcd_put_cur(0, 0);
lcd_send_string("Sending to   ");
HAL_Delay(100);
lcd_put_cur(1, 0);
lcd_send_string(" Server...");
HAL_Delay(10);
server(read_id, granted, granted_count, denied_count);
 lcd_clear();
lcd_put_cur(0, 0);
lcd_send_string("Sent ");
 HAL_Delay(100);
 lcd_put_cur(1, 0);
 lcd_send_string(" Successfully...");
HAL_Delay(10);


loop_count++;
//count=0;


				  break;
				  }
				  else
				  {
					  /*
					  lcd_clear();
					  lcd_put_cur(0, 0);
					  lcd_send_string("ACCESS   ");
		              HAL_Delay(100);
			          lcd_put_cur(1, 0);
					  lcd_send_string("  DENIED   ");
				      HAL_Delay(1000);*/
					  loop_count++;
					  count1=0;
				  }

			  }

			  if(granted)
			  {
				  granted=0;
			  }
			  else
			  {
				  lcd_clear();
				  lcd_put_cur(0, 0);

				  denied_count ++;
				 					  					  lcd_send_string("ACCESS   ");
				 					  		              HAL_Delay(100);
				 					  			          lcd_put_cur(1, 0);
				 					  					  lcd_send_string("  DENIED   ");
				 					  				      HAL_Delay(1000);

				 					  				      granted=0;
				 					  				   //set_servo_angle(0);


				 					  				   lcd_clear();
				 					  				   lcd_put_cur(0, 0);
				 					  				   lcd_send_string("Sending to   ");
				 					  				   HAL_Delay(100);
				 					  				   lcd_put_cur(1, 0);
				 					  				   lcd_send_string(" Server...");
				 					  				   HAL_Delay(10);
				 					  				   server(read_id,granted, granted_count, denied_count);
				 					  				    lcd_clear();
				 					  				   lcd_put_cur(0, 0);
				 					  				   lcd_send_string("Sent ");
				 					  				    HAL_Delay(100);
				 					  				    lcd_put_cur(1, 0);
				 					  				    lcd_send_string(" Successfully...");
				 					  				   HAL_Delay(10);




			  }

			  HAL_Delay(30);
			 // W25qxx_ReadSector(card_buffer,1,0,12);
			  HAL_Delay(30);


			  HAL_Delay(3);
			  					   for(int i=0;i<=11;i++)
			  					   {
			  					   Rx_data[i]=0;
			  					   HAL_Delay(3);
			  					   Rx_data1[i]=0;
			  					   HAL_Delay(3);
			  					   }
			  			           HAL_Delay(3);


		  }
		  }



void servo_initialise()
{
set_servo_angle(0);
}


void set_servo_angle(uint8_t angle)
{
	htim3.Instance->CCR1 = (angle * 400 / 18) + 500;
	htim3.Instance->CCR2 = (angle * 400 / 18) + 500;

}
void server(int id, int acess_status, int count_granted, int count_denied) {
	printf("AT\r\n");
	HAL_Delay(1000);

	printf("AT+CPIN?\r\n");
	HAL_Delay(1000);

	printf("AT+CREG?\r\n");
	HAL_Delay(1000);

	printf("AT+CGATT?\r\n");
	HAL_Delay(1000);

	printf("AT+CIPSHUT\r\n");
	HAL_Delay(1000);

	printf("AT+CIPSTATUS\r\n");
	HAL_Delay(2000);

	printf("AT+CIPMUX=0\r\n");
	HAL_Delay(2000);

	printf("AT+CSTT=\"airtelgprs.com\"\r\n"); //start task and setting the APN,
	HAL_Delay(1000);

	printf("AT+CIICR\r\n"); //bring up wireless connection
	HAL_Delay(3000);

	printf("AT+CIFSR\r\n"); //get local IP adress
	HAL_Delay(2000);

	printf("AT+CIPSPRT=0\r\n");
	HAL_Delay(3000);

	printf("AT+CIPSTART=\"TCP\",\"api.thingspeak.com\",\"80\"\r\n"); //start up the connection
	HAL_Delay(4000);

	printf("AT+CIPSEND\r\n"); //begin send data to remote server
	HAL_Delay(4000);

	//String str="GET https://api.thingspeak.com/update?api_key=QOBMDZ6X2L2DW6XK&field1=" + String(150);
	printf("%s", stri);
	//printf("%c", *stri);
	//printf("GET https://api.thingspeak.com/update?api_key=T5YROORK1XWC50XO&field1=");
	// for(int i=0;i<=11;i++)

	printf("%d", id);  //  printf("%d",num[i]) // to send exact id

	printf("&field2=");
	printf("%d", acess_status);

	printf("&field3=");
	printf("%d", count_granted);

	printf("&field4=");
	printf("%d", count_denied);

	printf("\r\n");

	//  printf("GET https://api.thingspeak.com/update?api_key=QOBMDZ6X2L2DW6XK&field1=300\r\n");
	//printf(str);//begin send data to remote server

	HAL_Delay(4000);

	printf("%c", (char) 0x1A);	  //sending
	// HAL_UART_Transmit(&huart3, (uint8_t *)0x26, 1, 0xFFFF);
	printf("\r\n");
	HAL_Delay(4000);//waitting for reply, important! the time is base on the condition of internet
	printf("\r\n");
	// printf("\r\n");

	printf("AT+CIPSHUT\r\n");	 //close the connection
	HAL_Delay(100);

}


void compare(int *a1, int *a2, int n)
{
	int i, flag = 0;
	for(i = 0; i < n; i++)
	{
		if(*a1 != *a2)
		{
			flag = 1;
			break;
		}
		a1++;
		a2++;
	}
	if(flag == 1)
		printf("\nBoth arrays are not equal");
	else
		printf("\nBoth arrays are equal");
}








/* USER CODE END 4 */

/**
  * @brief  This function is executed in case of error occurrence.
  * @retval None
  */
void Error_Handler(void)
{
  /* USER CODE BEGIN Error_Handler_Debug */
  /* User can add his own implementation to report the HAL error return state */
  __disable_irq();
  while (1)
  {
  }
  /* USER CODE END Error_Handler_Debug */
}

#ifdef  USE_FULL_ASSERT
/**
  * @brief  Reports the name of the source file and the source line number
  *         where the assert_param error has occurred.
  * @param  file: pointer to the source file name
  * @param  line: assert_param error line source number
  * @retval None
  */
void assert_failed(uint8_t *file, uint32_t line)
{
  /* USER CODE BEGIN 6 */
  /* User can add his own implementation to report the file name and line number,
     ex: printf("Wrong parameters value: file %s on line %d\r\n", file, line) */
  /* USER CODE END 6 */
}
#endif /* USE_FULL_ASSERT */
